#include <stdio.h>
#include <time.h>
#include <stdlib.h>

// ----------------------------------------------- Grupa A
int brojParnihZnamenki( int x )
{
	int br = 0;
	while( x != 0 )
	{
		if( (x % 10) % 2 == 0 )
			++br;
			
		x = x / 10;
	}

	return br;
}

int aa( int jmbagovi[], int bodovi[], int n, int BOD )
{
	int i;
	
	for( i = 0; i < n; ++i )
		if( bodovi[ i ] == BOD )
			return jmbagovi[ i ];
			
	return -1;
}

int ab( int jmbagovi[], int bodovi[], int n, int JMBAG )
{
	int lo = 0, hi = n-1, mid;
	
	while( lo <= hi )
	{
		mid = ( lo + hi ) / 2;
		if( brojParnihZnamenki( jmbagovi[ mid ] ) == brojParnihZnamenki( JMBAG ) )
		{
			int i = mid;
			while( i >= 0 && brojParnihZnamenki( jmbagovi[ i ] ) == brojParnihZnamenki( JMBAG ) )
			{
				if( jmbagovi[ i ] == JMBAG )
					return bodovi[ i ];
				--i;
			}

			i = mid+1;						
			while( i < n && brojParnihZnamenki( jmbagovi[ i ] ) == brojParnihZnamenki( JMBAG ) )
			{
				if( jmbagovi[ i ] == JMBAG )
					return bodovi[ i ];
				++i;
			}
			
			return -1;
		}
		else if( brojParnihZnamenki( jmbagovi[ mid ] ) < brojParnihZnamenki( JMBAG ) )
			lo = mid + 1;
		else // brojParnihZnamenki( jmbagovi[ mid ] ) > brojParnihZnamenki( JMBAG )
			hi = mid - 1;
	}

	return -1;
}

// ----------------------------------------------- Grupa B
int sumaNeparnihZnamenki( int x )
{
	int br = 0;
	while( x != 0 )
	{
		if( (x % 10) % 2 == 1 )
			br += ( x % 10 );
			
		x = x / 10;
	}

	return br;
}

int ba( int cijene[], int barkodovi[], int n, int BARKOD )
{
	int lo = 0, hi = n-1, mid;
	
	while( lo <= hi )
	{
		mid = ( lo + hi ) / 2;
		if( sumaNeparnihZnamenki( barkodovi[ mid ] ) == sumaNeparnihZnamenki( BARKOD ) )
		{
			int i = mid;
			while( i >= 0 && sumaNeparnihZnamenki( barkodovi[ i ] ) == sumaNeparnihZnamenki( BARKOD ) )
			{
				if( barkodovi[ i ] == BARKOD )
					return cijene[ i ];
				--i;
			}

			i = mid+1;						
			while( i < n && sumaNeparnihZnamenki( barkodovi[ i ] ) == sumaNeparnihZnamenki( BARKOD ) )
			{
				if( barkodovi[ i ] == BARKOD )
					return cijene[ i ];
				++i;
			}
			
			return -1;
		}
		else if( sumaNeparnihZnamenki( barkodovi[ mid ] ) < sumaNeparnihZnamenki( BARKOD ) )
			lo = mid + 1;
		else // sumaNeparnihZnamenki( barkodovi[ mid ] ) > sumaNeparnihZnamenki( BARKOD )
			hi = mid - 1;
	}

	return -1;
}

int bb( int cijene[], int barkodovi[], int n, int CIJENA )
{
	int i;
	
	for( i = 0; i < n; ++i )
		if( cijene[ i ] == CIJENA )
			return barkodovi[ i ];
			
	return -1;
}


// ----------------------------------------------- Grupa C
int brojZnamenki( int x )
{
	int br = 0;
	while( x != 0 )
	{
		++br;		
		x = x / 10;
	}

	return br;
}

int ca( int place[], int oibovi[], int n, int OIB )
{
	int i;
	
	for( i = 0; i < n; ++i )
		if( oibovi[ i ] == OIB )
			return place[ i ];
			
	return -1;
}

int cb( int place[], int oibovi[], int n, int PLACA )
{
	int lo = 0, hi = n-1, mid;
	
	while( lo <= hi )
	{
		mid = ( lo + hi ) / 2;
		if( brojZnamenki( place[ mid ] ) == brojZnamenki( PLACA ) )
		{
			int i = mid;
			while( i >= 0 && brojZnamenki( place[ i ] ) == brojZnamenki( PLACA ) )
			{
				if( place[ i ] == PLACA )
					return oibovi[ i ];
				--i;
			}

			i = mid+1;						
			while( i < n && brojZnamenki( place[ i ] ) == brojZnamenki( PLACA ) )
			{
				if( place[ i ] == PLACA )
					return oibovi[ i ];
				++i;
			}
			
			return -1;
		}
		else if( brojZnamenki( place[ mid ] ) > brojZnamenki( PLACA ) )
			lo = mid + 1;
		else // brojZnamenki( place[ mid ] ) < brojZnamenki( PLACA )
			hi = mid - 1;
	}

	return -1;
}

// ----------------------------------------------- Grupa D
int prvaZnamenka( int x )
{
	int br = 0;
	while( x != 0 )
	{
		br = x % 10;
		x = x / 10;
	}
	
	return br;
}

int da( int jmbagovi[], int bodovi[], int n, int BOD )
{
	int lo = 0, hi = n-1, mid;
	
	while( lo <= hi )
	{
		mid = ( lo + hi ) / 2;
		if( prvaZnamenka( bodovi[ mid ] ) == prvaZnamenka( BOD ) )
		{
			int i = mid;
			while( i >= 0 && prvaZnamenka( bodovi[ i ] ) == prvaZnamenka( BOD ) )
			{
				if( bodovi[ i ] == BOD )
					return jmbagovi[ i ];
				--i;
			}

			i = mid+1;						
			while( i < n && prvaZnamenka( bodovi[ i ] ) == prvaZnamenka( BOD ) )
			{
				if( bodovi[ i ] == BOD )
					return jmbagovi[ i ];
				++i;
			}
			
			return -1;
		}
		else if( prvaZnamenka( bodovi[ mid ] ) > prvaZnamenka( BOD ) )
			lo = mid + 1;
		else // prvaZnamenka( bodovi[ mid ] ) < prvaZnamenka( BOD )
			hi = mid - 1;
	}

	return -1;
}

int db( int jmbagovi[], int bodovi[], int n, int JMBAG )
{
	int i;
	
	for( i = 0; i < n; ++i )
		if( jmbagovi[ i ] == JMBAG )
			return bodovi[ i ];
			
	return -1;
}


// ----------------------------------------------- main (ne treba pisati)
void permute( int x[] )
{
	int i;
	for( i = 0; i < 1000; ++i )
	{
		int a = rand() % 1000, b = rand() % 1000, tmp;
		tmp = x[ a ]; x[ a ] = x[ b ]; x[ b ] = tmp;
	}
}

void sortiraj( int a[], int (*f)(int x), int sgn )
{
	int i, j;
	for( i = 0; i < 1000; ++i )
		for( j = i+1; j < 1000; ++j )
			if( sgn*f( a[ i ] ) > sgn*f( a[ j ] ) )
			{
				int tmp;
				tmp = a[ i ]; a[ i ] = a[ j ]; a[ j ] = tmp;
			}
}

int main( void )
{
	int a[ 1000 ], b[ 1000 ], i;
	
	srand( time( 0 ) );
	for( i = 0; i < 1000; ++i )
		a[ i ] = i, b[ i ] = i;
		
	printf( "Ako nema drugog ispisa osim ovog, onda sve radi :)\n" );	
		
	// Grupa A
	permute( a ); permute( b );
	sortiraj( a, brojParnihZnamenki, 1 );

	for( i = 0; i < 1000; ++i )
		if( aa( a, b, 1000, b[i] ) != a[i] )
			printf( "aaBUG! " );
	if( aa( a, b, 1000, 1001 ) != -1 )
			printf( "aaBUG! " );			
	
	for( i = 0; i < 1000; ++i )
		if( ab( a, b, 1000, a[i] ) != b[i] )
			printf( "abBUG! " );
	if( ab( a, b, 1000, 1001 ) != -1 )
			printf( "abBUG! " );			
	
	// Grupa B
	permute( a ); permute( b );
	sortiraj( b, sumaNeparnihZnamenki, 1 );

	for( i = 0; i < 1000; ++i )
		if( ba( a, b, 1000, b[i] ) != a[i] )
			printf( "baBUG! " );
	if( ba( a, b, 1000, 1001 ) != -1 )
			printf( "baBUG! " );			
	
	for( i = 0; i < 1000; ++i )
		if( bb( a, b, 1000, a[i] ) != b[i] )
			printf( "bbBUG! " );
	if( bb( a, b, 1000, 1001 ) != -1 )
			printf( "bbBUG! " );			

	// Grupa C
	permute( a ); permute( b );
	sortiraj( a, brojZnamenki, -1 );

	for( i = 0; i < 1000; ++i )
		if( ca( a, b, 1000, b[i] ) != a[i] )
			printf( "caBUG! " );
	if( ca( a, b, 1000, 1001 ) != -1 )
			printf( "caBUG! " );			
	
	for( i = 0; i < 1000; ++i )
		if( cb( a, b, 1000, a[i] ) != b[i] )
			printf( "cbBUG! " );
	if( cb( a, b, 1000, 1001 ) != -1 )
			printf( "cbBUG! " );			

	// Grupa D
	permute( a ); permute( b );
	sortiraj( b, prvaZnamenka, -1 );

	for( i = 0; i < 1000; ++i )
		if( da( a, b, 1000, b[i] ) != a[i] )
			printf( "daBUG! " );
	if( da( a, b, 1000, 1001 ) != -1 )
			printf( "daBUG! " );			
	
	for( i = 0; i < 1000; ++i )
		if( db( a, b, 1000, a[i] ) != b[i] )
			printf( "dbBUG! " );
	if( db( a, b, 1000, 1001 ) != -1 )
			printf( "dbBUG! " );			

	return 0;
}
